## odpi 5.0.1

=== Makefile ===
#------------------------------------------------------------------------------
# Copyright (c) 2016, 2023, Oracle and/or its affiliates.
#
# This software is dual-licensed to you under the Universal Permissive License
# (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
# 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose
# either license.
#
# If you elect to accept the software under the Apache License, Version 2.0,
# the following applies:
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# Sample Makefile showing how ODPI-C can be built as a shared library on
# platforms other than Windows. For Windows, see Makefile.win32.
#
# See https://oracle.github.io/odpi/doc/installation.html
# for the platforms and compilers known to work.
#------------------------------------------------------------------------------

vpath %.c src
vpath %.h include src

PREFIX ?= /usr/local
INSTALL_LIB_DIR = $(PREFIX)/lib
INSTALL_INC_DIR = $(PREFIX)/include
INSTALL_SHARE_DIR = $(PREFIX)/share/odpi

BUILD_DIR = build
LIB_DIR = lib
SAMPLES_DIR = samples
TESTS_DIR = test

CC = gcc
LD = gcc
AWK = awk

MAJOR_VERSION := $(shell $(AWK) '/define.*DPI_MAJOR_VERSION/ {print $$3}' \
	include/dpi.h )
MINOR_VERSION := $(shell $(AWK) '/define.*DPI_MINOR_VERSION/ {print $$3}' \
	include/dpi.h )
PATCH_LEVEL := $(shell $(AWK) '/define.*DPI_PATCH_LEVEL/ {print $$3}' \
	include/dpi.h )

INSTALL = install
CFLAGS = -Iinclude -O2 -g -Wall -Wextra -fPIC
LIBS = -ldl -lpthread
LDFLAGS = -shared
VERSION_LIB_NAME = $(LIB_NAME).$(MAJOR_VERSION)
FULL_LIB_NAME = $(VERSION_LIB_NAME).$(MINOR_VERSION).$(PATCH_LEVEL)
ifeq ($(shell uname -s), Darwin)
	LIB_NAME = libodpic.dylib
	LIB_OUT_OPTS = -dynamiclib \
		-install_name $(shell pwd)/$(LIB_DIR)/$(LIB_NAME) \
		-o $(LIB_DIR)/$(FULL_LIB_NAME)
else
	LIB_NAME = libodpic.so
	LIB_OUT_OPTS = -o $(LIB_DIR)/$(FULL_LIB_NAME)
	LDFLAGS += -Wl,-soname,$(LIB_NAME).$(MAJOR_VERSION)
endif

SRCS = dpiConn.c dpiContext.c dpiData.c dpiEnv.c dpiError.c dpiGen.c \
       dpiGlobal.c dpiLob.c dpiObject.c dpiObjectAttr.c dpiObjectType.c \
       dpiPool.c dpiStmt.c dpiUtils.c dpiVar.c dpiOracleType.c dpiSubscr.c \
       dpiDeqOptions.c dpiEnqOptions.c dpiMsgProps.c dpiRowid.c dpiOci.c \
       dpiDebug.c dpiHandlePool.c dpiHandleList.c dpiSodaColl.c \
       dpiSodaCollCursor.c dpiSodaDb.c dpiSodaDoc.c dpiSodaDocCursor.c \
       dpiQueue.c dpiJson.c dpiStringList.c
OBJS = $(SRCS:%.c=$(BUILD_DIR)/%.o)

SAMPLES_FILES := $(SAMPLES_DIR)/Makefile $(SAMPLES_DIR)/README.md \
		$(wildcard $(SAMPLES_DIR)/*.c) $(wildcard $(SAMPLES_DIR)/*.h) \
		$(wildcard $(SAMPLES_DIR)/sql/*.sql)
SAMPLES_TARGETS := $(SAMPLES_FILES:%=$(INSTALL_SHARE_DIR)/%)
INSTALL_SAMPLES_SQL_DIR := $(INSTALL_SHARE_DIR)/$(SAMPLES_DIR)/sql

TESTS_FILES := $(TESTS_DIR)/Makefile $(TESTS_DIR)/README.md \
		$(wildcard $(TESTS_DIR)/*.c) $(wildcard $(TESTS_DIR)/*.h) \
		$(wildcard $(TESTS_DIR)/sql/*.sql)
TESTS_TARGETS := $(TESTS_FILES:%=$(INSTALL_SHARE_DIR)/%)
INSTALL_TESTS_SQL_DIR := $(INSTALL_SHARE_DIR)/$(TESTS_DIR)/sql

INSTALL_TARGETS = $(INSTALL_INC_DIR)/dpi.h \
		$(INSTALL_LIB_DIR)/$(LIB_NAME) $(INSTALL_LIB_DIR)/$(FULL_LIB_NAME) \
		$(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME) $(INSTALL_SHARE_DIR)

all: $(LIB_DIR)/$(FULL_LIB_NAME) $(LIB_DIR)/$(VERSION_LIB_NAME) \
		$(LIB_DIR)/$(LIB_NAME)

clean:
	rm -rf $(BUILD_DIR) $(LIB_DIR)

$(BUILD_DIR):
	mkdir -p $(BUILD_DIR)

$(LIB_DIR):
	mkdir -p $(LIB_DIR)

$(BUILD_DIR)/%.o: %.c dpi.h dpiImpl.h dpiErrorMessages.h
	$(CC) -c $(CFLAGS) $< -o $@

$(LIB_DIR)/$(FULL_LIB_NAME): $(BUILD_DIR) $(LIB_DIR) $(OBJS)
	$(LD) $(LDFLAGS) $(LIB_OUT_OPTS) $(OBJS) $(LIBS)

$(LIB_DIR)/$(VERSION_LIB_NAME): $(LIB_DIR)/$(FULL_LIB_NAME)
	ln -sf $(FULL_LIB_NAME) $@

$(LIB_DIR)/$(LIB_NAME): $(LIB_DIR)/$(VERSION_LIB_NAME)
	ln -sf $(VERSION_LIB_NAME) $@

$(INSTALL_LIB_DIR):
	mkdir -p $@

$(INSTALL_INC_DIR):
	mkdir -p $@

$(INSTALL_SAMPLES_SQL_DIR):
	mkdir -p $@

$(INSTALL_TESTS_SQL_DIR):
	mkdir -p $@

$(INSTALL_INC_DIR)/%.h: %.h
	$(INSTALL) $< $@

$(INSTALL_LIB_DIR)/$(FULL_LIB_NAME): $(LIB_DIR)/$(LIB_NAME)
	$(INSTALL) $< $@
	if test "`uname -s`" = Darwin; then \
			install_name_tool -id $(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME) $@; fi

$(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME): $(INSTALL_LIB_DIR)/$(FULL_LIB_NAME)
	ln -sf $(FULL_LIB_NAME) $@

$(INSTALL_LIB_DIR)/$(LIB_NAME): $(INSTALL_LIB_DIR)/$(VERSION_LIB_NAME)
	ln -sf $(VERSION_LIB_NAME) $@

$(INSTALL_SHARE_DIR)/%: %
	$(INSTALL) $< $@

install: $(INSTALL_SAMPLES_SQL_DIR) $(INSTALL_TESTS_SQL_DIR) \
		$(INSTALL_INC_DIR) $(INSTALL_LIB_DIR) $(INSTALL_TARGETS) \
		$(INSTALL_SHARE_DIR)/README.md $(INSTALL_SHARE_DIR)/LICENSE.txt \
		$(SAMPLES_TARGETS) $(TESTS_TARGETS)

uninstall:
	rm -rf $(INSTALL_TARGETS)

=== doc/Makefile ===
#------------------------------------------------------------------------------
# Copyright (c) 2016, 2022, Oracle and/or its affiliates.
#
# This software is dual-licensed to you under the Universal Permissive License
# (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl and Apache License
# 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose
# either license.
#
# If you elect to accept the software under the Apache License, Version 2.0,
# the following applies:
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#------------------------------------------------------------------------------

# Makefile to generate ODPI-C documentation using Sphinx

SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SOURCEDIR     = src
BUILDDIR      = build

.PHONY: html
html:
	@$(SPHINXBUILD) -M html $(SOURCEDIR) $(BUILDDIR) $(SPHINXOPTS)

.PHONY: epub
epub:
	@$(SPHINXBUILD) -M epub $(SOURCEDIR) $(BUILDDIR) $(SPHINXOPTS)

.PHONY: pdf
pdf:
	@$(SPHINXBUILD) -M latexpdf $(SOURCEDIR) $(BUILDDIR) $(SPHINXOPTS)

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

=== doc/requirements.txt ===
sphinx>=4.2.0
sphinx-rtd-theme>=0.5.2

=== debian/changelog ===
odpi (5.0.1-0kali2) kali-dev; urgency=medium

  * Nitpicks in d/rules
  * Rewrite the one-liner to fix file mode bits
  * Drop dh-exec from Build-Depends
  * Bump standards version

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 21 May 2025 22:11:48 +0700

odpi (5.0.1-0kali1) kali-dev; urgency=medium

  [ Ben Wilson ]
  * Remove template comment and switch spaces to tabs

  [ Kali Janitor ]
  * Update standards version to 4.6.1, no changes needed.
  * Update standards version to 4.6.2, no changes needed.

  [ Steev Klimaszewski ]
  * New upstream version 5.0.1
  * Add new dependency
  * Update debian directory for 5.0.1 release.

 -- Steev Klimaszewski <steev@kali.org>  Tue, 14 Nov 2023 15:06:04 -0600

odpi (3.1.1-0kali2) kali-dev; urgency=medium

  [ Raphaël Hertzog ]
  * Update Maintainer field
  * Update Vcs-* fields for the move to gitlab.com
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Update URL in GitLab's CI configuration file

  [ Kali Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.

  [ Sophie Brun ]
  * Add missing sphindoc Depends

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 18 Dec 2020 16:08:35 +0100

odpi (3.1.1-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 19 Feb 2019 15:50:01 +0100

=== debian/control ===
Source: odpi
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 13), python3-sphinx, python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/oracle/odpi
Vcs-Browser: https://gitlab.com/kalilinux/packages/odpi
Vcs-Git: https://gitlab.com/kalilinux/packages/odpi.git

Package: libodpic-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libodpic5 (= ${binary:Version}), ${misc:Depends}
Suggests: libodpic-doc
Description: Oracle DB Programming Interface for Drivers and Applications (headers)
 This package contains Oracle Database Programming Interface for C (ODPI-C),
 an open source library of C code that simplifies access to Oracle Database for
 applications written in C or C++. It is a wrapper over Oracle Call Interface
 (OCI) that makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client.
 .
 This package contains the headers.

Package: libodpic5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libodpic-doc
Description: Oracle DB Programming Interface for Drivers and Applications (lib)
 This package contains Oracle Database Programming Interface for C (ODPI-C),
 an open source library of C code that simplifies access to Oracle Database for
 applications written in C or C++. It is a wrapper over Oracle Call Interface
 (OCI) that makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client.

Package: libodpic-doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Section: doc
Description: Oracle DB Programming Interface for Drivers and Applications (doc)
 This package contains Oracle Database Programming Interface for C (ODPI-C),
 an open source library of C code that simplifies access to Oracle Database for
 applications written in C or C++. It is a wrapper over Oracle Call Interface
 (OCI) that makes applications and language interfaces easier to develop.
 .
 ODPI-C supports basic and advanced features of Oracle Database and Oracle
 Client.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PREFIX = debian/tmp/usr

%:
	dh $@ --with sphinxdoc

execute_after_dh_auto_build:
	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml doc/src build/html

override_dh_installdocs:
	dh_installdocs -Xdoctrees

execute_before_dh_installexamples:
	find debian/tmp/usr/share/odpi/ -type f -exec chmod 0644 {} \;

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%odpi-$1.tar.gz%" \
   https://github.com/oracle/odpi/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
